from sys import setrecursionlimit
setrecursionlimit(10 ** 9)
def add(a, b, f=max):
    result = ['0']*max(len(a), len(b))
    for i in range(len(result)):
        if i >= len(a):
            result[i] = b[i]
        elif i >= len(b):
            result[i] = a[i]
        else:
            result[i] = f(a[i], b[i])
    return result
def mul(a, b):
    result_len = (len(a)+len(b)-1)
    result = ['0']*result_len
    for i in range(len(b)):
        mult = [b[i]]*len(a)
        to_add = ['0']*i
        to_add.extend(add(a, mult, f=min))
        result = add(to_add, result)
    return result

def main():
    a = list(input())
    
    b = list(input())
    a.reverse()
    b.reverse()
    sum = add(a, b)
    mult = mul(a, b)
    sum.reverse()
    mult.reverse()
    print(*sum, end=' ', sep='')
    print(*mult, sep='')
main()