#include <bits/stdc++.h>
struct ratio{
    uint32_t a, b;
    void normalize(){
        
        uint32_t d = std::gcd(a, b);
        a /= d;
        b /= d;
    }
    ratio& operator+=(ratio other){
        a += other.a;
        b += other.b;
        normalize();
        return *this;
    }
    ratio operator+(ratio other) const{
        return ratio(*this) += other;
    }
    bool operator<(ratio other) const{
        uint64_t d = std::lcm(b, other.b);
        return (d/b)*a < (d/other.b)*other.a;
    }
    bool operator==(ratio other) const{
        return a == other.a && b == other.b;
    }
    bool operator>(ratio other) const{
        return other < *this;
    }
};
const int iwastrying = 1e8;
bool recursion(std::string& answer, ratio left, ratio current, ratio right, ratio need){
    if (current == need)
        return true;
    if (answer.size() > iwastrying)
        return false;
    if (need < current){
        answer.push_back('L');
        return recursion(answer, left, left+current, current, need);
    }
    answer.push_back('R');
    return recursion(answer, current, right+current, right, need);
}
int main(){
    uint32_t a, b;
    std::cin >> a >> b;
    ratio need{a, b};
    need.normalize();
    ratio left{0, 1};
    ratio right{1, 0};
    std::string ans;
    if (recursion(ans, left, left, right, need)){
        std::cout << ans << std::endl;
    }
    else
        std::cout << "no" << std::endl;
}