#include <bits/stdc++.h>
struct guardian{
    int h;
    int node;
    bool operator<(guardian other) const{
        if (h == other.h)
            return node < other.node;
        return h < other.h;
    }
};
int main(){
    uint32_t n, m, k;
    std::cin >> n >> m >> k;
    std::vector<std::vector<int>> graph(n);
    std::vector<int> guard_h(n, -1);
    std::priority_queue<guardian> for_bfs;
    int answer_size = 0;
    for (int i = 0; i < m; i++)
    {
        int a, b;
        std::cin >> a >> b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    for (int i = 0; i < k; i++)
    {
        guardian g;
        std::cin >> g.node >> g.h;
        g.node--;
        if (guard_h[g.node] == -1)
            answer_size++;
        if (g.h > guard_h[g.node]){
            guard_h[g.node] = g.h;
            for_bfs.push(g);
        }
    }
    while (for_bfs.size()){
        guardian guard = for_bfs.top();
        for_bfs.pop();
        if (guard.h == 0 || guard_h[guard.node] > guard.h)
            continue;
        for (auto i : graph[guard.node]){
            if (guard.h-1 <= guard_h[i])
                continue;
            for_bfs.push(guardian{guard.h-1, i});
            guard_h[i] = guard.h-1;
            answer_size++;
        }
    }
    std::cout << answer_size << '\n';
    for (int i = 0; i < n; i++)
    {

        if (guard_h[i] != -1)
            std::cout << i+1 << ' ';
    }
    std::cout << '\n';
    
    
    
}